/*
Gemma the Tarsier-Cat 
Original Character by RalphJeremy65

Main Programming by SMS Alfredo
Extra Programming by reverbal & JABSphere
*/

/*
Futureproofing for v2.2.11 (Cause Uncapped do be spewing ye the 
"P_TeleportMove is deprecated" warning into your face) (Also thanks Lach)
*/
local P_MoveOrigin = P_MoveOrigin or P_TeleportMove
local P_SetOrigin = P_SetOrigin or P_TeleportMove

-- Gemma's bike (requires RushChars lol)
if not boatchars
	rawset(_G, "boatchars", {})
end
boatchars["gemma"] = {0, 1, 1}

freeslot("MT_GEMMAPLAT", "SPR_BLDR", "MT_GROCK", "SPR2_JSKI")

mobjinfo[MT_GEMMAPLAT] = {
	name = "rock platform",
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	deathsound = sfx_cdfm32,
	radius = 48*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = -1,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SLIDEME
}

-- rev: too much headache, may as well make it an object
mobjinfo[MT_GROCK] = {
		name = "rock crumbles",
		spawnstate = S_ROCKCRUMBLEB,
		radius = 8*FRACUNIT,
		height = 16*FRACUNIT,
		mass = 0,
		damage = 1,--0,
		flags = MF_SCENERY|MF_MISSILE|MF_NOCLIPHEIGHT -- MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_SCENERY|MF_NOCLIPHEIGHT 
}
local grock = MT_GROCK

//gemmastyle command
COM_AddCommand("gemmastyle", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0"
			CONS_Printf(player, "Style 0 for Gemma has been deprecated as of version 1.2. Defaulting to style 1.")
			player.gemmastyle = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "1" or arg == "default"
			player.gemmastyle = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "2"
			player.gemmastyle = 2
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(2)
				file:close()
			end
		else
			CONS_Printf(player, "gemmastyle - Changes how Gemma's jump ability controls.")
			CONS_Printf(player, "#1: Let go of Jump while riding the platform to hop off it.")
			CONS_Printf(player, "#2: Press Jump while riding the platform to hop off it.")
		end
	else
		CONS_Printf(player, "gemmastyle - Changes how Gemma's jump ability controls.")
		CONS_Printf(player, "#1: Let go of Jump while riding the platform to hop off it.")
		CONS_Printf(player, "#2: Press Jump while riding the platform to hop off it.")
	end
end, 0)

//Shatter the platform when it dies
addHook("MobjDeath", function(mobj)
	for i=0, 2
		//local ghost = P_SpawnGhostMobj(mobj)
		local ghost = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GHOST)
		if i == 1
			S_StartSound(ghost, mobj.info.deathsound)
		end
		ghost.scale = mobj.scale
		ghost.fuse = TICRATE
		ghost.flags = $&~MF_NOGRAVITY
		ghost.flags2 = mobj.flags2&MF2_OBJECTFLIP
		ghost.eflags = mobj.eflags&MFE_VERTICALFLIP
		ghost.state = mobj.state
		P_SetObjectMomZ(ghost, 4*FRACUNIT, false)
		if mobj.tracer and mobj.tracer.valid and mobj.tracer.player
			P_InstaThrust(ghost, (i*-ANGLE_90)+(mobj.tracer.player.cmd.angleturn<<16)+ANGLE_90, 4*mobj.scale)
		else
			P_InstaThrust(ghost, P_RandomKey(ANGLE_MAX), 4*mobj.scale)
		end
		ghost.sprite = SPR_BLDR
		ghost.frame = i+1
		i=$+1
	end
end, MT_GEMMAPLAT)

//Teleport the platform
addHook("MobjThinker", function(mobj)
	if gamestate ~= GS_LEVEL then return end
	if not mobj.tracer return end
	if not (mobj.tracer.valid and mobj.tracer.skin == "gemma"
	and mobj.tracer.player and mobj.tracer.player.gemmasmash > 1)
	or not (mobj.flags&MF_NOGRAVITY)
		if mobj.flags&MF_NOGRAVITY
			mobj.z = $-P_MobjFlip(mobj.tracer)
			mobj.flags = $&~MF_NOGRAVITY&~MF_NOCLIPHEIGHT
			mobj.momx = mobj.tracer.momx
			mobj.momy = mobj.tracer.momy
			mobj.fuse = TICRATE*3
			if mobj.tracer.valid and (P_IsObjectOnGround(mobj.tracer)
			or (mobj.tracer.player and mobj.tracer.player.pflags&PF_JUMPED
			and not (mobj.tracer.player.pflags&PF_THOKKED)
			and not (mobj.tracer.player.pflags&PF_SPINNING)))
				P_KillMobj(mobj)
				return
			elseif mobj.tracer.valid and mobj.tracer.player
			and mobj.tracer.player.pflags&PF_SPINNING
				mobj.z = $-mobj.tracer.height*P_MobjFlip(mobj.tracer)/2
				mobj.momx = $*4/5
				mobj.momy = $*4/5
			end
		elseif P_IsObjectOnGround(mobj)
			P_KillMobj(mobj)
			return
		end
	elseif mobj.tracer.eflags&MFE_VERTICALFLIP
		mobj.eflags = $|MFE_VERTICALFLIP
		mobj.flags2 = $|MF2_OBJECTFLIP
		P_MoveOrigin(mobj,mobj.tracer.x, mobj.tracer.y,
		mobj.tracer.z+mobj.tracer.height)
	else
		mobj.eflags = $&~MFE_VERTICALFLIP
		mobj.flags2 = $&~MF2_OBJECTFLIP
		P_MoveOrigin(mobj,mobj.tracer.x, mobj.tracer.y,
		mobj.tracer.z-mobj.height)
	end
end, MT_GEMMAPLAT)

//Die
addHook("MobjFuse", function(mobj)
	if gamestate ~= GS_LEVEL then return end
	P_KillMobj(mobj)
	return true
end, MT_GEMMAPLAT)

//Stupid
addHook("MobjThinker", function(mobj)
	if gamestate ~= GS_LEVEL then return end
	if mobj and mobj.valid and mobj.gemmarock
		mobj.gemmarock = $+1
		-- rev: Make object start to slowly fade away after a while.
		mobj.scale = $ - 2500 --P_RandomRange(3500, 5500)
		mobj.shadowscale = mobj.scale/4
		if (mobj.gemmarock > TICRATE*3)
			or mobj.scale < (FRACUNIT/2)
			or P_IsObjectOnGround(mobj)
		then
			//P_SpawnGhostMobj(mobj)
			local fade = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GHOST)
			fade.scale = mobj.scale
			fade.fuse = TICRATE/4
			fade.state = mobj.state
			fade.sprite = mobj.sprite
			fade.frame =  mobj.frame
			fade.frame = $|TR_TRANS50 
			P_RemoveMobj(mobj)
		end
	end
end, grock)

-- rev: gemma rock: don't give teammates rings, and don't consume the rocks either
-- rev: (made it a bit more organized)
addHook("ShouldDamage", function(target, inf, src, dmgtype)
	if gamestate ~= GS_LEVEL then return end
	if 	G_GametypeHasTeams()
		and target and target.player 
		and inf and inf.type == grock and inf.target and inf.target == src 
		and src.skin == "gemma"
		and target.player.ctfteam == src.player.ctfteam
	then
		return false
	end
end)
addHook("MobjCollide", function(mo, rock)
	if gamestate ~= GS_LEVEL then return end
	if 	(not G_GametypeHasTeams())
		or (not mo) 
		or (mo and not mo.player) 
	then 
		return 
	end
	
	if 	rock and rock.type == grock 
		and rock.target and rock.target.player and rock.target.skin == "gemma"
		and mo and mo.player and mo.player.ctfteam == rock.target.player.ctfteam
	then
		return false
	end
end, MT_PLAYER)


//Platform Collision: its a local function now because we need it for both of the MobjCollide hooks
local function PlatfromCollision(thing, tmthing)
	if gamestate ~= GS_LEVEL then return end
	local zset = false
	if thing and thing.valid and tmthing and tmthing.valid
		local splayer = thing.tracer and thing.tracer.valid and thing.tracer.player
		local tplayer = tmthing.player
		local gemmaspeed = thing.tracer.scale*3
		local platfromspeed = thing.tracer.scale*1
		local playerspeed = 1
		
		if thing.tracer and thing.tracer.valid and thing.flags&MF_NOGRAVITY then
			gemmaspeed = $+(FixedHypot(thing.tracer.momx, thing.tracer.momy))
		end

			platfromspeed = $+ FixedHypot(thing.momx, thing.momy)
			playerspeed = $+ FixedHypot(tmthing.momx, tmthing.momy)
		
		if thing.tracer == tmthing
			return false
			
		// we just jumped off the platform we dont want to go back on it
		elseif tplayer and tplayer.valid and (tplayer.cmd.buttons&PF_JUMPDOWN) then
			return false
		
		// dont carry the player if there too fast...
		elseif tplayer and tplayer.valid and
		playerspeed > (platfromspeed+gemmaspeed) then
			return false	
					
		elseif tmthing.flags&MF_SHOOTABLE
		and (not splayer or not tplayer or CV_FindVar("friendlyfire").value
		or not (gametyperules & GTR_FRIENDLY or (G_GametypeHasTeams() and splayer.ctfteam == tplayer.ctfteam)))
		and (tplayer or tmthing.flags&MF_MONITOR or not (tmthing.flags&MF_SOLID))
		and (thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z)
			if splayer and thing.flags&MF_NOGRAVITY
				splayer.gemmasmash = 0
				splayer.mo.state = S_PLAY_SPRING
				splayer.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE&~PF_THOKKED
				if splayer.cmd.buttons&BT_JUMP
					splayer.pflags = $|PF_STARTJUMP
				end
				splayer.mo.momz = abs($)*P_MobjFlip(splayer.mo)
			end
			
			thing.flags = $|MF_MISSILE
			
			if splayer
				if CBW_Battle and CBW_Battle.GuardTrigger(tmthing, thing.tracer, thing.tracer, 1, 0)
					P_KillMobj(thing)
				elseif (not CBW_Battle or CBW_Battle.PlayerCorkDamage(tmthing, thing, thing.tracer) != false)
				and thing and thing.valid
					P_DamageMobj(tmthing, thing, splayer.mo)
					P_KillMobj(thing)
				end
			else
				P_DamageMobj(tmthing, thing, thing)
				P_KillMobj(thing)
			end
			
			if thing and thing.valid
				thing.flags = $&~MF_MISSILE
			end
		
		zset = true // we dont want to run that last if statement now that we did this
		elseif not tplayer
			return false
			
		elseif P_IsObjectOnGround(tmthing) and not (tmthing.eflags&MFE_ONGROUND)
			if thing.tracer and thing.tracer.valid and thing.flags&MF_NOGRAVITY
			//after a speed check we adjust the postion of carryed players at least once to prevent them from falling off....
				if tmthing and tmthing.valid and playerspeed+(8*thing.tracer.scale) < (platfromspeed+gemmaspeed)
				and not tmthing.gemmacarryed and tmthing.gemmacarryed != thing then
					local dist = min((thing.radius*2),R_PointToDist2(thing.tracer.x, thing.tracer.y, tmthing.x, tmthing.y))
					local xsignt = 1
					local ysignt = 1
					local xsigns = 1
					local ysigns = 1
					if tmthing.x < 0 then
						xsignt = -1
					end
					if tmthing.y < 0 then
						ysignt = -1
					end
					if thing.tracer.x < 0 then
						xsigns = -1
					end
					if thing.tracer.y < 0 then
						ysigns= -1
					end
					local xdiff = (thing.tracer.x+(dist*xsigns))-(tmthing.x+(dist*xsignt))
					local ydiff = (thing.tracer.y+(dist*ysigns))-(tmthing.y+(dist*ysignt))
					local zdiff = thing.tracer.z-tmthing.z
					tmthing.momx = thing.tracer.momx
					tmthing.momy = thing.tracer.momy
					tmthing.momz = 0
					tplayer.cmd.forwardmove = 0
					tplayer.cmd.sidemove = 0
					P_MoveOrigin(tmthing, (tmthing.x+(xdiff/4)), (tmthing.y+(ydiff/4)),
						thing.tracer.z+(P_MobjFlip(thing.tracer)*thing.tracer.scale))
					zset = true

					if dist < 46*thing.scale then
						// we use gemmacarryed to make sure we only adjust once
						tmthing.gemmacarryed = thing
					else
						tmthing.gemmacarryed = thing //Im too lazzy to change it
						P_MoveOrigin(tmthing, (tmthing.x+(xdiff/3)), (tmthing.y+(ydiff/3)),
						 thing.tracer.z+(P_MobjFlip(thing.tracer)*thing.tracer.scale))
						tmthing.momx = thing.tracer.momx
						tmthing.momy = thing.tracer.momy
						tmthing.momz = 0
					end
					return false 
				end
				tmthing.momx = thing.tracer.momx
				tmthing.momy = thing.tracer.momy
				tmthing.momz = 0
				tmthing.gemmacarryed = nil //dont feel like writing it in the player hook so we nil it here 
				zset = true
			else
				tmthing.momx = thing.momx
				tmthing.momy = thing.momy
				tmthing.gemmacarryed = nil
				zset = true
			end
			if tmthing.state != S_PLAY_WALK and tmthing.momx == 0 and tmthing.momy == 0
			and (tplayer.cmd.forwardmove or tplayer.cmd.sidemove)
				tmthing.state = S_PLAY_WALK
			end
			tplayer.powers[pw_noautobrake] = max($,2)
		return
		end
	end
	// we dont want to collide with the sides of the platform too much...
	if tmthing.player and tmthing.player.valid and zset == false and tmthing and (
	(P_MobjFlip(tmthing) == 1 and tmthing.z+tmthing.height <= thing.z+tmthing.height)
	or (P_MobjFlip(tmthing) == -1 and tmthing.z >= thing.z) )then
		return false
	end
	
end

addHook("MobjCollide", PlatfromCollision, MT_GEMMAPLAT)
addHook("MobjMoveCollide", PlatfromCollision, MT_GEMMAPLAT)

//Platform Protection
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not (target and target.valid and target.player and target.skin == "gemma"
	and target.player.gemmasmash and target.player.gemmasmash >= 2 and not (damagetype&DMG_DEATHMASK)) then return end
	local inflvald = (inflictor and inflictor.valid)
	if (damagetype != DMG_WATER and not inflvald)
	or (inflvald and inflictor.type == MT_SPIKE
	and (target.eflags & MFE_VERTICALFLIP) == (inflictor.eflags & MFE_VERTICALFLIP))
	or (inflvald and not P_IsObjectOnGround(target)
	and inflictor.type != MT_WALLSPIKE)
	
	if inflvald
		local bottomheight = target.z
		local topheight = target.z + target.height

		if (target.eflags & MFE_VERTICALFLIP)
			local swap = bottomheight
			bottomheight = topheight
			topheight = swap
		end

		if not ((P_MobjFlip(target)*(bottomheight - (inflictor.z + inflictor.height/2)) > 0)
		and (P_MobjFlip(target)*(target.momz - inflictor.momz) < 0)) then return end
	
		target.z = $+(inflictor.height/2)
	else
		target.z = $+P_MobjFlip(target)
	end
	
	local spoark = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_THUNDERCOIN_SPARK)
	spoark.fuse = TICRATE/3
	spoark.scale = target.scale*3/2
	target.momz = max(abs(target.momz), 10*target.scale)
	target.player.gemmasmash = 0
	target.state = S_PLAY_SPRING
	target.player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_THOKKED
	if target.player.cmd.buttons&BT_JUMP
		target.player.pflags = $|PF_STARTJUMP
	end
	S_StartSound(target, sfx_cdfm65)
	
	return false end
end, MT_PLAYER)

//Start the ability
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "gemma" and player.panim != PA_PAIN
	and not player.gotflag and not player.gotcrystal
		if (player.gemmasmash and player.gemmasmash > 1)
		or player.gemmaspindash
			player.pflags = $&~PF_JUMPED
			P_DoJump(player)
			player.gemmasmash = 0
			if not (player.pflags&PF_SPINNING)
				player.pflags = $|PF_THOKKED&~PF_NOJUMPDAMAGE
			end
		elseif (not (player.pflags&PF_THOKKED) or player.charflags&SF_MULTIABILITY
		or player.powers[pw_super]) and not P_IsObjectInGoop(player.mo)
			player.gemmasmash = 1
			player.pflags = $|PF_THOKKED|PF_JUMPED&~PF_STARTJUMP&~PF_NOJUMPDAMAGE&~PF_SPINNING
			local dumbgravity = P_GetMobjGravity(player.mo)
			if player.mo.eflags&MFE_UNDERWATER and not P_IsObjectInGoop(player.mo)
			dumbgravity = player.mo.scale*2/-5*P_MobjFlip(player.mo) end
			if player.mo.eflags&MFE_UNDERWATER
				player.mo.momz = $+(max(min(dumbgravity,player.mo.scale/2),player.mo.scale/-2)*-32)
			else
				player.mo.momz = $+(max(min(dumbgravity,player.mo.scale/2),player.mo.scale/-2)*-48)
			end
			S_StartSound(player.mo, sfx_s3kabf)
		end
	end
end)

//Rock spindash
addHook("SpinSpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "gemma" and player.panim != PA_PAIN
	and player.gemmasmash
		if player.gemmasmash > 1
		and not (player.pflags&PF_USEDOWN) and not player.gemmaspindash
			player.gemmadashspeed = 15*FRACUNIT
			player.mo.state = S_PLAY_SPINDASH
			player.gemmaspindash = 1
			S_StartSound(player.mo, sfx_spndsh)
		end
		return true
	end
end)

//Bouncy
addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.skin == "gemma"
	and inflictor.player
		if inflictor.player.gemmasmash
			if inflictor.player.gemmasmash > 1
				inflictor.player.gemmasmash = 0
				inflictor.state = S_PLAY_SPRING
				inflictor.player.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE
				if inflictor.player.cmd.buttons&BT_JUMP
					inflictor.player.pflags = $|PF_STARTJUMP
				end
			else
				inflictor.momz = $*2
			end
		end
		inflictor.player.pflags = $&~PF_THOKKED
	end
end)

//Bouncy!
addHook("MobjDeath", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.skin == "gemma"
	and inflictor.player and target and target.valid and target.flags&MF_MONITOR
		if inflictor.player.gemmasmash
			if inflictor.player.gemmasmash > 1
				inflictor.player.gemmasmash = 0
				inflictor.state = S_PLAY_SPRING
				inflictor.player.pflags = $|PF_JUMPED|PF_STARTJUMP|PF_NOJUMPDAMAGE
				if inflictor.player.cmd.buttons&BT_JUMP
					inflictor.player.pflags = $|PF_STARTJUMP
				end
			else
				inflictor.momz = $*2
			end
		end
		inflictor.player.pflags = $&~PF_THOKKED
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "gemma"
	and player.gemmaspindash
		return true
	end
end)

//Reset Gemma's variables
local resetgemma = function(player)
	player.gemmamomz = 0
	if player.mo and player.mo.valid
	and (player.gemmasmash == 1 or player.gemmasquish)
		player.mo.spritexscale = FRACUNIT
		player.mo.spriteyscale = FRACUNIT
	end
	player.gemmasmash = 0
	player.gemmasquish = 0
	player.gemmaspindash = 0
end
addHook("PlayerSpawn", function(player)
	resetgemma(player)
	//I/O maybe
	if io and player.gemmastyle == nil and player == consoleplayer
		local file = io.openlocal("client/Gemma.dat")
		if file
			local num = file:read("*n")
			if num != nil and num >= 0 and num <= 2
				COM_BufInsertText(consoleplayer, "gemmastyle "..num)
			end
			file:close()
		end
	end
end)

//Main Thinker	
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "gemma"
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.gotflag
		or player.gotcrystal
		or player.iseggrobo
		or player.isjettysyn
		or player.guard
		or player.airdodge
		or player.actionstate
		or player.powers[pw_nocontrol]
		or player.exiting
			resetgemma(player)
			if player.charflags&SF_STOMPDAMAGE
				player.charflags = $&~SF_STOMPDAMAGE
			end
		return end
		
		//Do the ability
		if player.gemmasmash
			if player.gemmasmash == 1
				if P_IsObjectInGoop(player.mo)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.gemmasmash = 0
				elseif player.mo.eflags&MFE_SPRUNG
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					S_StartSound(player.mo, sfx_sprong)
					if (player.mo.eflags & MFE_UNDERWATER)
						local ex = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_UWEXPLODE)
						if ex and ex.valid ex.scale = $/2 end
					else
						P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale*P_MobjFlip(player.mo), MT_SPINDUST)
					end
					player.gemmasmash = 0
				elseif P_IsObjectOnGround(player.mo)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.gemmasquish = 4
					player.mo.state = S_PLAY_GLIDE_LANDING
					if player.powers[pw_super]
						P_Earthquake(player.mo, player.mo, RING_DIST)
					end
					if player == displayplayer and not splitscreen
						P_StartQuake(32*FRACUNIT, 2+min(player.powers[pw_super],1))
					end
					
					if player.cmd.buttons&BT_JUMP
						player.mo.momz = player.gemmamomz/-2
						if player.mo.momz*P_MobjFlip(player.mo) < 8*player.mo.scale
							P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
						end
						player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
						if player.gemmastyle == 2
							player.gemmasmash = 2
						else
							player.gemmasmash = 5
						end
						player.pflags = $|PF_JUMPSTASIS
						player.charflags = $|SF_STOMPDAMAGE
						local rock = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_GEMMAPLAT)
						rock.blockable = 1 -- 2 rev: Make it blockable ig..
						rock.block_stun = 3
						rock.block_sound = sfx_s3k49
						rock.block_hthrust = 6
						rock.block_vthrust = 2
						
						rock.sprite = SPR_BLDR
						rock.frame = 0
						rock.tracer = player.mo
						rock.target = player.mo
						rock.flags2 = $|MF2_LINKDRAW
						
						if RF_FLOORSPRITE
							//local ghost = P_SpawnGhostMobj(rock)
							local ghost = P_SpawnMobj(rock.x, rock.y, rock.z, MT_THOK)
							ghost.state = S_INVISIBLE  //rock.state
							ghost.sprite = rock.sprite
							ghost.scale = rock.scale
							ghost.frame = 4
							ghost.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_SHADOWDRAW|RF_OBJECTSLOPESPLAT
							P_CreateFloorSpriteSlope(ghost)
							ghost.flags = $&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
							ghost.flags2 = player.mo.flags2&MF2_OBJECTFLIP
							ghost.eflags = player.mo.eflags&MFE_VERTICALFLIP
							ghost.height = ghost.scale
							ghost.z = $ - rock.height*P_MobjFlip(ghost)
							ghost.fuse = TICRATE*5
							ghost.angle = player.cmd.angleturn<<16
						else
							local ghost = P_SpawnMobj(rock.x, rock.y, rock.z, MT_GHOST)
							ghost.frame = 4
							ghost.scale = rock.scale
							ghost.state = rock.state
							ghost.fuse = TICRATE
							ghost.angle = player.cmd.angleturn<<16
						end
						
						S_StartSound(player.mo, sfx_s3k82)
						S_StartSoundAtVolume(player.mo, sfx_s3k7a, 192)
						S_StartSoundAtVolume(player.mo, sfx_s1b9, 192)
					else
						S_StartSound(player.mo, sfx_s3k4c)
						S_StartSoundAtVolume(player.mo, sfx_s3k59, 192)
						player.gemmasmash = 0
					end
					
					local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
					thok.color = SKINCOLOR_BEIGE
					thok.destscale = thok.scale*16
					thok.scalespeed = $*2
					thok.tics = $*3/2
					thok.fuse = thok.tics
					
					local pmo = player.mo
					local i = 0	while i < 8
						local ns = 16 << FRACBITS
						local mo = P_SpawnMobj(pmo.x+pmo.scale, pmo.y+pmo.scale,
						(pmo.z)+(player.mo.height/2), grock)
						if mo and mo.valid
							mo.angle = (i*(ANGLE_180/4))
							if player.powers[pw_super]
								mo.momx = FixedMul(sin(mo.angle),ns)*2
								mo.momy = FixedMul(cos(mo.angle),ns)*2
							else
								mo.momx = FixedMul(sin(mo.angle),ns)/2
								mo.momy = FixedMul(cos(mo.angle),ns)/2
							end
							mo.scale = pmo.scale
							mo.gemmarock = 1
							mo.blockable = 1
							mo.block_stun = 4
							mo.block_sound = sfx_s3k49
							mo.block_hthrust = 3
							mo.block_vthrust = 1
							/*
							mo.hit_sound = sfx_hit04
							mo.blockable = 1
							mo.block_stun = 3
							mo.block_sound = sfx_s3k49
							mo.block_hthrust = 6
							mo.block_vthrust = 2
							*/
							mo.target = player.mo
							mo.shadowscale = FRACUNIT/3
							mo.radius = $*4
						end
						i = $+1
					end
					
					S_StopSoundByID(player.mo, sfx_s3kabf)
				else
					player.pflags = $|PF_JUMPSTASIS
					player.mo.state = S_PLAY_ROLL
					player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
					player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
					if player.cmd.buttons&BT_JUMP
						local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_GMATHOK)
						thok.color = player.mo.color
						thok.destscale = 1
						thok.scalespeed = thok.scale/6
						thok.tics = $*3/2
						thok.fuse = thok.tics
						thok.spritexscale = player.mo.spritexscale
						//thok.spriteyscale = player.mo.spriteyscale
						local thok = P_SpawnMobjFromMobj(player.mo,
						FixedDiv(player.mo.momx/-2,player.mo.scale),
						FixedDiv(player.mo.momy/-2,player.mo.scale),
						FixedDiv(player.mo.momz/-2,player.mo.scale),MT_GMATHOK)
						thok.color = player.mo.color
						thok.destscale = 1
						thok.scalespeed = thok.scale/6
						P_SetScale(thok, thok.scale-thok.scalespeed/2)
						thok.tics = $*3/2
						thok.fuse = thok.tics
						thok.spritexscale = player.mo.spritexscale
						//thok.spriteyscale = player.mo.spriteyscale
					else
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.color = SKINCOLOR_BEIGE
						ghost.colorized = true
						ghost.fuse = 4
						ghost.spritexscale = player.mo.spritexscale
						ghost.spriteyscale = player.mo.spriteyscale
					end
					if player.mo.momz*P_MobjFlip(player.mo) > -32*player.mo.scale
						player.mo.momz = $+(P_GetMobjGravity(player.mo)*8)
					elseif player.mo.momz*P_MobjFlip(player.mo) > -48*player.mo.scale
						player.mo.momz = $+(P_GetMobjGravity(player.mo)*2)
					end
					local sectorthing = player.mo.subsector and player.mo.subsector.sector
		            if sectorthing and sectorthing.valid then
			            for fof in sectorthing.ffloors()
				            if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					            local foffloor = fof.topheight
					            local fofceiling = fof.bottomheight
					            if fof.b_slope and fof.b_slope.valid
						            fofceiling = P_GetZAt(fof.b_slope, player.mo.x, player.mo.y)
					            end
					            if fof.t_slope and fof.t_slope.valid
						            foffloor = P_GetZAt(fof.t_slope, player.mo.x, player.mo.y)
					            end
					            if foffloor > player.mo.z + player.mo.momz and fofceiling < player.mo.z + player.mo.height + player.mo.momz
						            EV_CrumbleChain(nil, fof)
						            if fof.master.flags & ML_EFFECT5
							            P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, player.mo, sectorthing)
						            end
						            return true
					            end
				            end
			            end
		            end
				end
			elseif not (player.cmd.buttons&BT_JUMP) and player.gemmasmash == 5
				player.pflags = $&~PF_JUMPED
				P_DoJump(player)
				player.gemmasmash = 0
				player.pflags = $|PF_THOKKED&~PF_STARTJUMP&~PF_NOJUMPDAMAGE
			elseif P_IsObjectOnGround(player.mo)
			or player.pflags&PF_STARTJUMP
				player.gemmasmash = 0
			else
				player.pflags = $|PF_JUMPED
				if not player.gemmaspindash
					player.mo.state = S_PLAY_GLIDE_LANDING
				end
				if player.gemmasmash >= 3 and player.gemmasmash < 5
					if player.cmd.buttons&BT_JUMP
						player.gemmasmash = $+1
					else
						player.gemmasmash = 2
					end
				end
			end
			player.gemmamomz = player.mo.momz
		elseif player.charflags&SF_STOMPDAMAGE
			player.charflags = $&~SF_STOMPDAMAGE
		end
		
		if player.gemmasquish
			player.gemmasquish = $-1
			player.mo.spritexscale = FRACUNIT+(player.gemmasquish)*FRACUNIT/6
			player.mo.spriteyscale = FRACUNIT-(player.gemmasquish)*FRACUNIT/6
		end
		
		if player.gemmaspindash
			if player.gemmaspindash == -1
				player.gemmaspindash = 0
				player.pflags = $&~PF_JUMPED
				player.gemmasmash = 0
			elseif player.cmd.buttons & BT_SPIN
			and player.gemmasmash and player.gemmasmash > 1
				player.mo.state = S_PLAY_SPINDASH
				
				local chargecalculation = (6*(player.gemmadashspeed  - (player.mindash)))/((player.maxdash) - (player.mindash))
				player.gemmadashspeed = min(max($+FRACUNIT, player.mindash), player.maxdash)
				local soundcalculation = (6*(player.gemmadashspeed  - (player.mindash)))/((player.maxdash) - (player.mindash))
				if not player.spectator and soundcalculation != chargecalculation
					S_StartSound(player.mo, sfx_spndsh)
				end
			
				local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
					local particle
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SMALLBUBBLE)
					else
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
							particle.state = S_SPINDUST_FIRE1
						end
					end
				
					particle.target = player.mo
					particle.destscale = (2*player.mo.scale)/3
					P_SetScale(particle, particle.destscale)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						particle.z = player.mo.z + player.mo.height - particle.height
					end
					local prandom = {}
					prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
					prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
					prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
					P_SetObjectMomZ(particle, player.gemmadashspeed /50 + prandom[0], false)
					P_InstaThrust(particle,
							player.mo.angle + (prandom[1]*ANG1),
							-FixedMul(player.gemmadashspeed /12 + FRACUNIT + prandom[2], player.mo.scale))
					particle.momx = $+player.mo.momx
					particle.momy = $+player.mo.momy
					particle.momz = $+player.mo.momz
					P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				
					i = $+1
				end
			elseif not (player.cmd.buttons&BT_USE)
			or P_IsObjectOnGround(player.mo)
				P_InstaThrust(player.mo, player.mo.angle, FixedMul(player.gemmadashspeed , player.mo.scale))
				S_StartSound(player.mo, sfx_s23c)
				player.pflags = $|PF_SPINNING&~PF_THOKKED
				player.gemmaspindash = -1
				if player.mo.momz*P_MobjFlip(player.mo) < 0
					player.mo.momz = 0
				end
				player.mo.state = S_PLAY_ROLL
			else
				player.gemmaspindash = 0
			end
		end
	end
end)

// Stand Animation Fix
addHook("PlayerSpawn", function(p)
	-- rev: properly prevent game from raising warnings
    if (p and p.mo and p.mo.skin == "gemma")
        p.mo.state = $
    end
end)

// Extra Transform Sound 
// Idea totally not stolen from Flare v1.x lol
addHook("ThinkFrame", function()
	for player in players.iterate do
		-- rev: properly prevent game from raising warnings
		if not player.mo or (player.mo and player.mo.skin ~= "gemma") then continue end
		
		if player.mo.state == S_PLAY_SUPER_TRANS2 then
			S_StartSound(player.mo, sfx_s3k9f)
		end
	end
end)
